using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace PhysicsTestbed
{
	public class DragForce : MouseForce
	{
		public Particle selected;
		new bool oldLmbDown = false;

		public override void ApplyForce(IEnumerable particles)
		{
			const int CUTOFF = 100;
			//const float FORCE_MULT = 1f;
			const float PAUSED_MULT = 2f;
			Vector2 mouseVec = new Vector2(mouse.X, mouse.Y);

			if (lmbDown == true && oldLmbDown == false)
			{
				selected = null;
				double closestDist = CUTOFF;

				foreach (Particle t in particles)
				{
					double dist = (t.goal - mouseVec).Length();
					if (dist < closestDist)
					{
						closestDist = dist;
						selected = t;
					}
				}
			}

			if (selected != null)
			{
				if (selected.locked == false)
				{
					if (Testbed.paused == false && lmbDown)
					{
						selected.fExt += (mouseVec - selected.x) * selected.mass;
						selected.v = Vector2.ZERO;
					}
					else if (Testbed.paused == true && !lmbDown && oldLmbDown == true)
					{
						selected.fExt += (mouseVec - selected.x) * PAUSED_MULT * selected.mass;
					}
				}
				else if(lmbDown)
				{
					selected.x = mouseVec;
                    selected.v = Vector2.ZERO;
				}
			}

			oldLmbDown = lmbDown;
		}

		public bool Dragging
		{
			get 
			{
				return (lmbDown && selected != null);
			}
		}
	}
}
